// java CreateHistogram "d:\data\ganos\Desktop\Histo\CRW_3319_JFR.JPG" "d:\data\ganos\Desktop\Histo" "CRW_3319_JFR" 1 0 0 0

import java.awt.*;
import java.awt.image.*;
//import com.sun.image.codec.*; //jpeg reader /writer
import com.sun.image.codec.jpeg.*;
import java.io.*;
import javax.imageio.*;

public class CreateHistogram
{

	private static Histogram hist;          // histogram data to be displayed
    private static HistogramView view;
    
    public static void main(String[] args)
    {
        // use double quotes when spaces are in file names
        
        if (args.length < 7)
        {
            // bands =0 no histogram made, =1 histogram made for that band
            // outBase name is appended with _histogramColor.png
            System.out.println("Usage: CreateHistogram inpufile outputdir outBaseName red_band green_band blue_band rgb_band");
            System.out.println("You supplied " + args.length + ", 7 are needed");
            return;
        }
        
        //String infile = new String("d:\\data\\ganos\\Desktop\\Histo\\CRW_3319_JFR.JPG");
        //String outfile = new String("d:\\data\\ganos\\Desktop\\Histo\\CRW_3319_JFR_red.png");
        //int band = 3;
        
        String infile = args[0];
        String outfileDir = args[1];
        String outfileBase = args[2];
        int red_band = Integer.parseInt(args[3]);
        int green_band = Integer.parseInt(args[4]);
        int blue_band = Integer.parseInt(args[5]);
        int rgb_band = Integer.parseInt(args[6]);
        
         boolean histSuccess = true;
         if(red_band == 1)
         {
             histSuccess =  create(infile,outfileDir + "\\" + outfileBase + "_red.png", 0);//red histogram
             if(!histSuccess)
             {
                 // output error message
                 System.out.println("Error: creating red Histogram");
             }
         } // red Histogram
         if(green_band == 1)
         {
             histSuccess =  create(infile,outfileDir + "\\" + outfileBase + "_green.png", 1);//red histogram
             if(!histSuccess)
             {
                 // output error message
                 System.out.println("Error: creating green Histogram");
             }
         } // green Histogram
         if(blue_band == 1)
         {
             histSuccess =  create(infile,outfileDir + "\\" + outfileBase + "_blue.png", 2);//red histogram
             if(!histSuccess)
             {
                 // output error message
                 System.out.println("Error: creating blue Histogram");
             }
         } // blue Histogram
         if(rgb_band == 1)
         {
             histSuccess =  create(infile,outfileDir + "\\" + outfileBase + "_rgb.png", 3);//red histogram
             if(!histSuccess)
             {
                 // output error message
                 System.out.println("Error: creating RGB Histogram");
             }
         } // blue Histogram
         
         
        
    }
    
    
    // imageIn = image to create histogram of
    // band = which bad to create histogram, 0=Red(or grayscale),1=G.2=Blue,3=averaged
    // outputPNGfile = filename of output PNG file string
    public static boolean create(String inputPNGfile, String outputPNGfile, int band)
    {
        // stuff
        //System.out.println("===  Testing Image Features ===");

        BufferedImage image = new BufferedImage(300,200,BufferedImage.TYPE_3BYTE_BGR); // width, height, type
        Graphics2D g = image.createGraphics();

        // load in jpg image
        BufferedImage imageIn = new BufferedImage(300,200,BufferedImage.TYPE_3BYTE_BGR);
        try
		{
		    FileInputStream fileStreamIn = new FileInputStream(inputPNGfile);
		    JPEGImageDecoder input = JPEGCodec.createJPEGDecoder(fileStreamIn);
			imageIn = input.decodeAsBufferedImage();
		}
		catch(IOException e)
		{
		    System.out.println("ERROR reading input jpg for Histogram: "+e);//
        }


        // create an instance of the Histogram class
        try
        {
			hist = new Histogram(imageIn );
        }
		catch (Exception e)
		{
		        System.err.println(e);
		        System.exit(1);
        }

		// create a instance of HistogramView class.. for creating histogram graphic
        //int band = 3; // band 0=R,1=G,2=B, 3=gray(of color image)
        view = new HistogramView(hist,band);

        // TO TEST IF IMAGE IS GRAY SCALE
        // hist.getNumBands()
        
        
        // NEED A COMBINED histogram (R+G+B)/3


		// background for image
        g.setColor(Color.WHITE);
        g.fillRect(0,0,300,200);


        // draw histogram
        if(band == 0)
        	view.setColor(Color.red);
        if(band == 1)
        	view.setColor(Color.green);
        if(band == 2)
        	view.setColor(Color.blue);
        if(band == 3)
            view.setColor(Color.gray);

		view.paintComponent(g);


        // write jpg file
        // NOTE TO SAVE TO PNG -- good idea!
        // http://javaalmanac.com/egs/javax.imageio/Graphic2File.html
        try
        {
            /*
            FileOutputStream filestream = new FileOutputStream("out.jpg");
            JPEGImageEncoder output = JPEGCodec.createJPEGEncoder(filestream);

            JPEGEncodeParam param = output.getDefaultJPETestImageGEncodeParam(image);
            param.setQuality(0.99f, true);
            output.setJPEGEncodeParam(param);

            output.encode(image);
             */ // JPEG output
             
            // save PNG file
            File file = new File(outputPNGfile);
            ImageIO.write(image, "png", file);
            
        }
        catch(IOException e)
        {
            System.out.println("Exception: "+e);//
        }
        
        // change for if band was availible
        boolean bandAvail = true;
        if(band > 0 && hist.getNumBands() == 1)
            bandAvail = false; // nope not a band that is availible
        return bandAvail;

        //System.out.println("===  DONE ===");
    } // main

} //TestImage

